
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Community_reactionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const community_reactions = await db.community_reactions.create(
            {
                id: data.id || undefined,
        
        reaction_type: data.reaction_type
        ||
        null
            ,
            
        reacted_at: data.reacted_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await community_reactions.setUser( data.user || null, {
            transaction,
        });
        
        await community_reactions.setPost( data.post || null, {
            transaction,
        });
        
        await community_reactions.setComment( data.comment || null, {
            transaction,
        });
        

        

        

        return community_reactions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const community_reactionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                reaction_type: item.reaction_type
            ||
            null
            ,
            
                reacted_at: item.reacted_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const community_reactions = await db.community_reactions.bulkCreate(community_reactionsData, { transaction });

        // For each item created, replace relation files
        

        return community_reactions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const community_reactions = await db.community_reactions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.reaction_type !== undefined) updatePayload.reaction_type = data.reaction_type;
        
        
        if (data.reacted_at !== undefined) updatePayload.reacted_at = data.reacted_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await community_reactions.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await community_reactions.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.post !== undefined) {
            await community_reactions.setPost(
              
              data.post,
              
              { transaction }
            );
        }
        
        if (data.comment !== undefined) {
            await community_reactions.setComment(
              
              data.comment,
              
              { transaction }
            );
        }
        

        
        

        

        return community_reactions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const community_reactions = await db.community_reactions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of community_reactions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of community_reactions) {
                await record.destroy({transaction});
            }
        });


        return community_reactions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const community_reactions = await db.community_reactions.findByPk(id, options);

        await community_reactions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await community_reactions.destroy({
            transaction
        });

        return community_reactions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const community_reactions = await db.community_reactions.findOne(
            { where },
            { transaction },
        );

        if (!community_reactions) {
            return community_reactions;
        }

        const output = community_reactions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await community_reactions.getUser({
            transaction
        });
        
        
        output.post = await community_reactions.getPost({
            transaction
        });
        
        
        output.comment = await community_reactions.getComment({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.community_posts,
        as: 'post',
        
        where: filter.post ? {
          [Op.or]: [
            { id: { [Op.in]: filter.post.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.post.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.community_comments,
        as: 'comment',
        
        where: filter.comment ? {
          [Op.or]: [
            { id: { [Op.in]: filter.comment.split('|').map(term => Utils.uuid(term)) } },
            {
              body: {
                [Op.or]: filter.comment.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.reacted_atRange) {
                const [start, end] = filter.reacted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reacted_at: {
                    ...where.reacted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reacted_at: {
                    ...where.reacted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.reaction_type) {
                where = {
                    ...where,
                reaction_type: filter.reaction_type,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.community_reactions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'community_reactions',
                        'reaction_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.community_reactions.findAll({
            attributes: [ 'id', 'reaction_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reaction_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reaction_type,
        }));
    }

    
};

